

use pubs
go	

drop table t1
drop table t2

create table t1 (
  col1 int,
  col2 int, 
  col3 int
)
go

insert t1 values(1,2,3)
insert t1 values(4,5,6)
insert t1 values(7,8,null)
go

create table t2 (
  col1 int,
  col2 int, 
  col3 int
)
go

insert t2 values(1,2,3)
insert t2 values(4,5,6)
insert t2 values(7,8,9)
go

select * from t1
select * from t2

select col1, col2, col3 from t1

select * from t1
except
select * from t2

-- same answer
select * from t1 
 where not exists(
   select * from t2 
   where t2.col1 = t1.col1 
   and   t2.col2 = t1.col2
   and   t2.col3 = t1.col3)
go


insert t2 values(7,8,null)
go

-- now that there are rows that "match"
-- and one col has a "matching" value of NULL
-- NULLS are "equal" in except
select * from t1
except
select * from t2

-- different answer
-- NULLS don't count as equal in exist
select * from t1 
 where not exists(
   select * from t2 
   where t2.col1 = t1.col1 
   and   t2.col2 = t1.col2
   and   t2.col3 = t1.col3)
go

-- intersect works this way too
select * from t1
intersect 
select * from t2

select * from t1 
 where exists(
   select * from t2 
   where t2.col1 = t1.col1 
   and   t2.col2 = t1.col2
   and   t2.col3 = t1.col3)
go
 